type Nullable<T> = T | null | undefined
export declare namespace kotlin.collections {
    interface KtList<E> /* extends kotlin.collections.Collection<E> */ {
        asJsReadonlyArrayView(): ReadonlyArray<E>;
        readonly __doNotUseOrImplementIt: {
            readonly "kotlin.collections.KtList": unique symbol;
        };
    }
    const KtList: {
        fromJsArray<E>(array: ReadonlyArray<E>): kotlin.collections.KtList<E>;
    };
    interface KtSet<E> /* extends kotlin.collections.Collection<E> */ {
        asJsReadonlySetView(): ReadonlySet<E>;
        readonly __doNotUseOrImplementIt: {
            readonly "kotlin.collections.KtSet": unique symbol;
        };
    }
    const KtSet: {
        fromJsSet<E>(set: ReadonlySet<E>): kotlin.collections.KtSet<E>;
    };
}
export declare namespace com.macrofocus.common.math.big {
    interface BigDecimal /* extends kotlin.Comparable<com.macrofocus.common.math.big.BigDecimal> */ {
        readonly absoluteValue: com.macrofocus.common.math.big.BigDecimal;
        readonly signum: number;
        readonly scale: number;
        readonly precision: number;
        readonly unscaledValue: com.macrofocus.common.math.big.BigInteger;
        plus(augend: Nullable<com.macrofocus.common.math.big.BigDecimal>): com.macrofocus.common.math.big.BigDecimal;
        plusWithContext(augend: Nullable<com.macrofocus.common.math.big.BigDecimal>, mc: com.macrofocus.common.math.big.MathContext): com.macrofocus.common.math.big.BigDecimal;
        minus(subtrahend: com.macrofocus.common.math.big.BigDecimal): com.macrofocus.common.math.big.BigDecimal;
        minusWithContext(subtrahend: com.macrofocus.common.math.big.BigDecimal, mc: com.macrofocus.common.math.big.MathContext): com.macrofocus.common.math.big.BigDecimal;
        times(multiplicand: Nullable<com.macrofocus.common.math.big.BigDecimal>): com.macrofocus.common.math.big.BigDecimal;
        timesWithContext(multiplicand: com.macrofocus.common.math.big.BigDecimal, mc: com.macrofocus.common.math.big.MathContext): com.macrofocus.common.math.big.BigDecimal;
        div(divisor: com.macrofocus.common.math.big.BigDecimal): com.macrofocus.common.math.big.BigDecimal;
        divWithContext(divisor: com.macrofocus.common.math.big.BigDecimal, mc: com.macrofocus.common.math.big.MathContext): Nullable<com.macrofocus.common.math.big.BigDecimal>;
        divideToIntegralValue(divisor: com.macrofocus.common.math.big.BigDecimal): com.macrofocus.common.math.big.BigDecimal;
        divideToIntegralValueWithContext(divisor: com.macrofocus.common.math.big.BigDecimal, mc: com.macrofocus.common.math.big.MathContext): com.macrofocus.common.math.big.BigDecimal;
        rem(divisor: com.macrofocus.common.math.big.BigDecimal): com.macrofocus.common.math.big.BigDecimal;
        remWithContext(divisor: com.macrofocus.common.math.big.BigDecimal, mc: com.macrofocus.common.math.big.MathContext): com.macrofocus.common.math.big.BigDecimal;
        divideAndRemainder(divisor: com.macrofocus.common.math.big.BigDecimal): any/* kotlin.Pair<com.macrofocus.common.math.big.BigDecimal, com.macrofocus.common.math.big.BigDecimal> */;
        divideAndRemainderWithContext(divisor: com.macrofocus.common.math.big.BigDecimal, mc: com.macrofocus.common.math.big.MathContext): any/* kotlin.Pair<com.macrofocus.common.math.big.BigDecimal, com.macrofocus.common.math.big.BigDecimal> */;
        sqrt(mc?: com.macrofocus.common.math.big.MathContext): com.macrofocus.common.math.big.BigDecimal;
        pow(n: number): com.macrofocus.common.math.big.BigDecimal;
        powWithContext(n: number, mc: com.macrofocus.common.math.big.MathContext): Nullable<com.macrofocus.common.math.big.BigDecimal>;
        absoluteValueWithContext(mc: com.macrofocus.common.math.big.MathContext): Nullable<com.macrofocus.common.math.big.BigDecimal>;
        unaryMinus(): com.macrofocus.common.math.big.BigDecimal;
        unaryMinusWithContext(mc: com.macrofocus.common.math.big.MathContext): Nullable<com.macrofocus.common.math.big.BigDecimal>;
        unaryPlus(): com.macrofocus.common.math.big.BigDecimal;
        unaryPlusWithContext(mc: com.macrofocus.common.math.big.MathContext): Nullable<com.macrofocus.common.math.big.BigDecimal>;
        round(mc: com.macrofocus.common.math.big.MathContext): Nullable<com.macrofocus.common.math.big.BigDecimal>;
        setScaleRounding(newScale: number, roundingMode: com.macrofocus.common.math.big.RoundingMode): com.macrofocus.common.math.big.BigDecimal;
        /** @deprecated The method {@link #setScale(int, RoundingMode)} should be used in preference to this legacy method. */
        setScaleInt(newScale: number, roundingMode: number): com.macrofocus.common.math.big.BigDecimal;
        setScale(newScale: number): com.macrofocus.common.math.big.BigDecimal;
        movePointLeft(n: number): com.macrofocus.common.math.big.BigDecimal;
        movePointRight(n: number): com.macrofocus.common.math.big.BigDecimal;
        scaleByPowerOfTen(n: number): com.macrofocus.common.math.big.BigDecimal;
        stripTrailingZeros(): com.macrofocus.common.math.big.BigDecimal;
        min(val: com.macrofocus.common.math.big.BigDecimal): com.macrofocus.common.math.big.BigDecimal;
        max(val: com.macrofocus.common.math.big.BigDecimal): com.macrofocus.common.math.big.BigDecimal;
        toEngineeringString(): string;
        toPlainString(): string;
        toBigInteger(): com.macrofocus.common.math.big.BigInteger;
        toBigIntegerExact(): com.macrofocus.common.math.big.BigInteger;
        toLong(): any/* kotlin.Long */;
        toLongExact(): any/* kotlin.Long */;
        toInt(): number;
        toByte(): number;
        toChar(): any/* kotlin.Char */;
        toShort(): number;
        toIntExact(): number;
        toShortExact(): number;
        toByteExact(): number;
        toFloat(): number;
        toDouble(): number;
        ulp(): com.macrofocus.common.math.big.BigDecimal;
        readonly __doNotUseOrImplementIt: {
            readonly "com.macrofocus.common.math.big.BigDecimal": unique symbol;
        };
    }
    const BigDecimal: {
        get ZERO(): com.macrofocus.common.math.big.BigDecimal;
        get ONE(): com.macrofocus.common.math.big.BigDecimal;
        get TWO(): com.macrofocus.common.math.big.BigDecimal;
        get TEN(): com.macrofocus.common.math.big.BigDecimal;
        get ONE_TENTH(): com.macrofocus.common.math.big.BigDecimal;
        get ONE_HALF(): com.macrofocus.common.math.big.BigDecimal;
        get PI(): com.macrofocus.common.math.big.BigDecimal;
        get E(): com.macrofocus.common.math.big.BigDecimal;
        ofScaledLong(unscaledVal: any/* kotlin.Long */, scale: number): com.macrofocus.common.math.big.BigDecimal;
        ofScaledLongWithPrecision(unscaledVal: any/* kotlin.Long */, scale: number, prec: number): com.macrofocus.common.math.big.BigDecimal;
        ofInt(val: number): com.macrofocus.common.math.big.BigDecimal;
        of(val: any/* kotlin.Long */): com.macrofocus.common.math.big.BigDecimal;
        ofScaledBigIntegerWithPrecision(intVal: com.macrofocus.common.math.big.BigInteger, scale: number, prec: number): com.macrofocus.common.math.big.BigDecimal;
        ofDouble(val: number, ctx?: Nullable<com.macrofocus.common.math.big.MathContext>): com.macrofocus.common.math.big.BigDecimal;
        ofFloat(val: number, ctx?: Nullable<com.macrofocus.common.math.big.MathContext>): com.macrofocus.common.math.big.BigDecimal;
        parse(val: string, ctx?: Nullable<com.macrofocus.common.math.big.MathContext>): com.macrofocus.common.math.big.BigDecimal;
        ofBigInteger(val: com.macrofocus.common.math.big.BigInteger, ctx?: Nullable<com.macrofocus.common.math.big.MathContext>): com.macrofocus.common.math.big.BigDecimal;
        ofIntWithContext(val: number, ctx: com.macrofocus.common.math.big.MathContext): com.macrofocus.common.math.big.BigDecimal;
        ofWithContext(val: any/* kotlin.Long */, ctx: com.macrofocus.common.math.big.MathContext): com.macrofocus.common.math.big.BigDecimal;
    };
}
export declare namespace com.macrofocus.common.math.big {
    interface BigInteger /* extends kotlin.Comparable<com.macrofocus.common.math.big.BigInteger> */ {
        readonly absoluteValue: com.macrofocus.common.math.big.BigInteger;
        readonly signum: number;
        readonly bitLength: number;
        readonly bitCount: number;
        rangeTo(endInclusive: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigIntegerRange;
        rangeToInt(endInclusive: number): com.macrofocus.common.math.big.BigIntegerRange;
        rangeToLong(endInclusive: any/* kotlin.Long */): com.macrofocus.common.math.big.BigIntegerRange;
        nextProbablePrime(): com.macrofocus.common.math.big.BigInteger;
        plus(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        plusInt(other: number): com.macrofocus.common.math.big.BigInteger;
        plusLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        minus(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        minusInt(other: number): com.macrofocus.common.math.big.BigInteger;
        minusLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        times(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        timesInt(other: number): com.macrofocus.common.math.big.BigInteger;
        timesLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        div(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        divInt(other: number): com.macrofocus.common.math.big.BigInteger;
        divLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        divideAndRemainder(other: com.macrofocus.common.math.big.BigInteger): Array<com.macrofocus.common.math.big.BigInteger>;
        divideAndRemainderInt(other: number): Array<com.macrofocus.common.math.big.BigInteger>;
        divideAndRemainderLong(other: any/* kotlin.Long */): Array<com.macrofocus.common.math.big.BigInteger>;
        reminder(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        reminderInt(other: number): com.macrofocus.common.math.big.BigInteger;
        reminderLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        pow(exponent: number): com.macrofocus.common.math.big.BigInteger;
        sqrt(): com.macrofocus.common.math.big.BigInteger;
        sqrtAndRemainder(): Array<com.macrofocus.common.math.big.BigInteger>;
        gcd(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        gcdInt(other: number): com.macrofocus.common.math.big.BigInteger;
        gcdLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        unaryMinus(): com.macrofocus.common.math.big.BigInteger;
        unaryPlus(): com.macrofocus.common.math.big.BigInteger;
        rem(modulus: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        remInt(modulus: number): com.macrofocus.common.math.big.BigInteger;
        remLong(modulus: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        modPow(exponent: com.macrofocus.common.math.big.BigInteger, modulus: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        modInverse(modulus: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        modInverseInt(modulus: number): com.macrofocus.common.math.big.BigInteger;
        modInverseLong(modulus: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        shl(n: number): com.macrofocus.common.math.big.BigInteger;
        shr(n: number): com.macrofocus.common.math.big.BigInteger;
        and(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        andInt(other: number): com.macrofocus.common.math.big.BigInteger;
        andLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        or(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        orInt(other: number): com.macrofocus.common.math.big.BigInteger;
        orLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        xor(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        xorInt(other: number): com.macrofocus.common.math.big.BigInteger;
        xorLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        not(): com.macrofocus.common.math.big.BigInteger;
        andNot(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        andNotInt(other: number): com.macrofocus.common.math.big.BigInteger;
        andNotLong(other: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        testBit(n: number): boolean;
        get(n: number): boolean;
        set(n: number, b: boolean): com.macrofocus.common.math.big.BigInteger;
        setBit(n: number): com.macrofocus.common.math.big.BigInteger;
        clearBit(n: number): com.macrofocus.common.math.big.BigInteger;
        flipBit(n: number): com.macrofocus.common.math.big.BigInteger;
        isProbablePrime(certainty: number): boolean;
        equals(other: Nullable<any>): boolean;
        min(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        max(other: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigInteger;
        hashCode(): number;
        toStringWithRadix(radix: number): string;
        toString(): string;
        toByteArray(): Int8Array;
        toInt(): number;
        toLong(): any/* kotlin.Long */;
        toByte(): number;
        toChar(): any/* kotlin.Char */;
        toShort(): number;
        toFloat(): number;
        toDouble(): number;
        toLongExact(): any/* kotlin.Long */;
        toIntExact(): number;
        toShortExact(): number;
        toByteExact(): number;
        readonly __doNotUseOrImplementIt: {
            readonly "com.macrofocus.common.math.big.BigInteger": unique symbol;
        };
    }
    const BigInteger: {
        get ZERO(): com.macrofocus.common.math.big.BigInteger;
        get ONE(): com.macrofocus.common.math.big.BigInteger;
        get TWO(): com.macrofocus.common.math.big.BigInteger;
        get NEGATIVE_ONE(): com.macrofocus.common.math.big.BigInteger;
        get TEN(): com.macrofocus.common.math.big.BigInteger;
        probablePrime(bitLength: number, rnd: any/* kotlin.random.Random */): com.macrofocus.common.math.big.BigInteger;
        ofLong(value: any/* kotlin.Long */): com.macrofocus.common.math.big.BigInteger;
        of(value: number): com.macrofocus.common.math.big.BigInteger;
        parse(value: string): com.macrofocus.common.math.big.BigInteger;
        parseWithRadix(value: string, radix: number): com.macrofocus.common.math.big.BigInteger;
        ofIntArray(value: Int32Array): com.macrofocus.common.math.big.BigInteger;
        ofSlideIntArray(signum: number, magnitude: Int8Array, off: number, len: number): com.macrofocus.common.math.big.BigInteger;
    };
}
export declare namespace com.macrofocus.common.math.big {
    class BigIntegerRange /* implements kotlin.ranges.ClosedRange<com.macrofocus.common.math.big.BigInteger>, kotlin.collections.Iterable<com.macrofocus.common.math.big.BigInteger> */ {
        constructor(start: com.macrofocus.common.math.big.BigInteger, endInclusive: com.macrofocus.common.math.big.BigInteger);
        copy(start?: com.macrofocus.common.math.big.BigInteger, endInclusive?: com.macrofocus.common.math.big.BigInteger): com.macrofocus.common.math.big.BigIntegerRange;
        toString(): string;
        hashCode(): number;
        equals(other: Nullable<any>): boolean;
    }
}
export declare namespace com.macrofocus.common.math.big {
    class MathContext {
        constructor(precision?: number, roundingMode?: com.macrofocus.common.math.big.RoundingMode);
        get precision(): number;
        get roundingMode(): com.macrofocus.common.math.big.RoundingMode;
        copy(precision?: number, roundingMode?: com.macrofocus.common.math.big.RoundingMode): com.macrofocus.common.math.big.MathContext;
        toString(): string;
        hashCode(): number;
        equals(other: Nullable<any>): boolean;
        static get Companion(): {
            get UNLIMITED(): com.macrofocus.common.math.big.MathContext;
            get DECIMAL32(): com.macrofocus.common.math.big.MathContext;
            get DECIMAL64(): com.macrofocus.common.math.big.MathContext;
            get DECIMAL128(): com.macrofocus.common.math.big.MathContext;
        };
    }
}
export declare namespace com.macrofocus.common.math.big {
    abstract class RoundingMode {
        private constructor();
        static get UP(): com.macrofocus.common.math.big.RoundingMode & {
            get name(): "UP";
            get ordinal(): 0;
        };
        static get DOWN(): com.macrofocus.common.math.big.RoundingMode & {
            get name(): "DOWN";
            get ordinal(): 1;
        };
        static get CEILING(): com.macrofocus.common.math.big.RoundingMode & {
            get name(): "CEILING";
            get ordinal(): 2;
        };
        static get FLOOR(): com.macrofocus.common.math.big.RoundingMode & {
            get name(): "FLOOR";
            get ordinal(): 3;
        };
        static get HALF_UP(): com.macrofocus.common.math.big.RoundingMode & {
            get name(): "HALF_UP";
            get ordinal(): 4;
        };
        static get HALF_DOWN(): com.macrofocus.common.math.big.RoundingMode & {
            get name(): "HALF_DOWN";
            get ordinal(): 5;
        };
        static get HALF_EVEN(): com.macrofocus.common.math.big.RoundingMode & {
            get name(): "HALF_EVEN";
            get ordinal(): 6;
        };
        static get UNNECESSARY(): com.macrofocus.common.math.big.RoundingMode & {
            get name(): "UNNECESSARY";
            get ordinal(): 7;
        };
        get name(): "UP" | "DOWN" | "CEILING" | "FLOOR" | "HALF_UP" | "HALF_DOWN" | "HALF_EVEN" | "UNNECESSARY";
        get ordinal(): 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7;
        get value(): number;
        static values(): Array<com.macrofocus.common.math.big.RoundingMode>;
        static valueOf(value: string): com.macrofocus.common.math.big.RoundingMode;
        static get Companion(): {
            valueOfInt(rm: number): com.macrofocus.common.math.big.RoundingMode;
        };
    }
}
export declare namespace com.macrofocus.common.properties {
    class PropertyEvent<T> {
        constructor(oldValue: T, newValue: T);
        get oldValue(): T;
        get newValue(): T;
        toString(): string;
        copy(oldValue?: T, newValue?: T): com.macrofocus.common.properties.PropertyEvent<T>;
        hashCode(): number;
        equals(other: Nullable<any>): boolean;
    }
}
export declare namespace com.macrofocus.common.properties {
    class SimpleProperty<T> /* extends com.macrofocus.common.properties.AbstractMutableProperty<T> */ /* implements com.macrofocus.common.properties.MutableProperty<T> */ {
        constructor(value: T);
        toString(): string;
        static get Companion(): {
            newInstance<T>(value: T): com.macrofocus.common.properties.SimpleProperty<T>;
        };
    }
}
export declare namespace com.macrofocus.common.collection {
    class JsArrayList<E> /* extends kotlin.collections.ArrayList<E> */ implements kotlin.collections.KtList<E> {
        constructor(elements: Array<E>);
        asJsReadonlyArrayView(): ReadonlyArray<E>;
        readonly __doNotUseOrImplementIt: kotlin.collections.KtList<E>["__doNotUseOrImplementIt"];
    }
}
export declare namespace com.macrofocus.common.math.big {
    function bigInteger(x: any): com.macrofocus.common.math.big.BigInteger;
    function bigDecimal(x: any): com.macrofocus.common.math.big.BigDecimal;
}
export declare namespace org.mkui.labeling {
    class EnhancedLabel {
        constructor();
        get isOpaque(): boolean;
        set isOpaque(value: boolean);
        get properties(): any/* com.macrofocus.common.properties.MutableProperties<Nullable<string>> */;
        set properties(value: any/* com.macrofocus.common.properties.MutableProperties<Nullable<string>> */);
        static fromString(text: Nullable<string>): org.mkui.labeling.EnhancedLabel;
        setName(name: Nullable<string>): void;
        getName(): Nullable<string>;
        getText(): Nullable<string>;
        setText(text: Nullable<string>): void;
        get isHTML(): boolean;
        set isHTML(value: boolean);
        getFont(): Nullable<any>/* Nullable<org.mkui.font.crossplatform.CPFont> */;
        setFont(font: any/* org.mkui.font.crossplatform.CPFont */): void;
        getVerticalAlignment(): number;
        setVerticalAlignment(verticalAlignment: number): void;
        getHorizontalAlignment(): number;
        setHorizontalAlignment(horizontalAlignment: number): void;
        getHeight(): Nullable<number>;
        getWidth(): Nullable<number>;
        getBackground(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setBackground(background: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getForeground(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setForeground(foreground: any/* org.mkui.color.crossplatform.CPColor */): void;
        isEnabled(): boolean;
        getInsetTop(): number;
        getInsetLeft(): number;
        getInsetBottom(): number;
        getInsetRight(): number;
        setInsetTop(value: number): void;
        setInsetLeft(value: number): void;
        setInsetBottom(value: number): void;
        setInsetRight(value: number): void;
        setInsets(top: number, left: number, bottom: number, right: number): void;
        getEffect(): org.mkui.labeling.EnhancedLabel.Effect;
        setEffect(effect: org.mkui.labeling.EnhancedLabel.Effect): void;
        getEffectOpacity(): number;
        setEffectOpacity(effectOpacity: number): void;
        getRendering(): org.mkui.labeling.EnhancedLabel.Rendering;
        setRendering(rendering: org.mkui.labeling.EnhancedLabel.Rendering): void;
        getMinimumCharactersToDisplay(): Nullable<number>;
        setMinimumCharactersToDisplay(minimumCharactersToDisplay: Nullable<number>): void;
        isJustified(): boolean;
        setJustified(justified: boolean): void;
        getAngle(): number;
        setAngle(angle: number): void;
        getDesiredWidth(): number;
        setDesiredWidth(desiredSize: number): void;
        getDesiredHeight(): number;
        setDesiredHeight(desiredSize: number): void;
        static get Companion(): {
            get CENTER(): number;
            get TOP(): number;
            get LEFT(): number;
            get BOTTOM(): number;
            get RIGHT(): number;
            get HORIZONTAL(): number;
            get VERTICAL(): number;
            get LEADING(): number;
            get TRAILING(): number;
            get NEXT(): number;
        };
    }
    namespace EnhancedLabel {
        abstract class Rendering {
            private constructor();
            static get Truncate(): org.mkui.labeling.EnhancedLabel.Rendering & {
                get name(): "Truncate";
                get ordinal(): 0;
            };
            static get Clip(): org.mkui.labeling.EnhancedLabel.Rendering & {
                get name(): "Clip";
                get ordinal(): 1;
            };
            static get WordWrap(): org.mkui.labeling.EnhancedLabel.Rendering & {
                get name(): "WordWrap";
                get ordinal(): 2;
            };
            get name(): "Truncate" | "Clip" | "WordWrap";
            get ordinal(): 0 | 1 | 2;
            static values(): Array<org.mkui.labeling.EnhancedLabel.Rendering>;
            static valueOf(value: string): org.mkui.labeling.EnhancedLabel.Rendering;
        }
        abstract class Effect {
            protected constructor();
            static get Plain(): {
            } & org.mkui.labeling.EnhancedLabel.Effect;
            static get Shadow(): {
            } & org.mkui.labeling.EnhancedLabel.Effect;
            static get Glow(): {
            } & org.mkui.labeling.EnhancedLabel.Effect;
            static get Outline(): {
            } & org.mkui.labeling.EnhancedLabel.Effect;
            static get Emphasize(): {
            } & org.mkui.labeling.EnhancedLabel.Effect;
        }
    }
}
export declare namespace org.mkui.palette {
    class InterpolatedPalette /* extends org.mkui.palette.FixedPalette */ {
        constructor(entries: kotlin.collections.KtSet<org.mkui.palette.InterpolatedPalette.Entry>/* com.macrofocus.common.collection.SortedSet<org.mkui.palette.InterpolatedPalette.Entry> */);
        get entries(): kotlin.collections.KtSet<org.mkui.palette.InterpolatedPalette.Entry>/* com.macrofocus.common.collection.SortedSet<org.mkui.palette.InterpolatedPalette.Entry> */;
        set entries(value: kotlin.collections.KtSet<org.mkui.palette.InterpolatedPalette.Entry>/* com.macrofocus.common.collection.SortedSet<org.mkui.palette.InterpolatedPalette.Entry> */);
        static paletteConstructor(p: Palette): org.mkui.palette.InterpolatedPalette;
        static entriesConstructor(e: Array<org.mkui.palette.InterpolatedPalette.Entry>): org.mkui.palette.InterpolatedPalette;
        getEntries(): kotlin.collections.KtSet<org.mkui.palette.InterpolatedPalette.Entry>;
    }
    namespace InterpolatedPalette {
        class Entry /* implements kotlin.Comparable<org.mkui.palette.InterpolatedPalette.Entry> */ {
            constructor(fraction: number, color: any/* org.mkui.color.crossplatform.CPColor */);
            get fraction(): number;
            getColor(): any/* org.mkui.color.crossplatform.CPColor */;
            equals(other: Nullable<any>): boolean;
            hashCode(): number;
        }
    }
}
export declare namespace org.mkui.palette {
    class PaletteFactory {
        constructor();
        getEntries(): kotlin.collections.KtList<org.mkui.palette.PaletteFactory.Entry>;
        getPalette(name: string): Palette;
        add(entry: org.mkui.palette.PaletteFactory.Entry): void;
        get(name: string): Nullable<org.mkui.palette.PaletteFactory.Entry>;
        find(palette: Nullable<Palette>): Nullable<org.mkui.palette.PaletteFactory.Entry>;
        createDefaultDivergingPalette(): any/* org.mkui.palette.FixedPalette */;
        createDefaultSequentialPalette(): any/* org.mkui.palette.FixedPalette */;
        createDefaultQualititativePalette(): any/* org.mkui.palette.FixedPalette */;
        createColorGradient(name: string): Nullable<any>/* Nullable<org.mkui.palette.MutablePalette> */;
        static get Companion(): {
            get instance(): org.mkui.palette.PaletteFactory;
        };
    }
    namespace PaletteFactory {
        class Entry {
            constructor(name: string, type: any/* org.mkui.palette.PaletteType */, colors: any/* org.mkui.palette.FixedPalette */);
            get name(): string;
            get type(): any/* org.mkui.palette.PaletteType */;
            getPalette(): any/* org.mkui.palette.FixedPalette */;
        }
    }
}
export declare namespace org.mkui.canvas {
    interface FunctionalReactCanvasProps extends Props {
    }
}
export declare namespace org.mkui.color {
    function colorOf(r: number, g: number, b: number, a: number): any/* org.mkui.color.crossplatform.CPColor */;
}
export declare namespace org.molap.dataframe {
    class DefaultDataFrame /* extends org.molap.dataframe.AbstractDataFrame<number, string, Nullable<any>> */ {
        constructor(dataFrame: any/* org.molap.dataframe.DataFrame<Nullable<any>, Nullable<any>, Nullable<any>> */);
        get series(): Array<any/* org.molap.series.Series<number, Nullable<any>> */>;
    }
}
export declare namespace org.molap.network {
    interface Graph<Vertex, Edge> {
        readonly nodes: any/* kotlin.collections.Iterable<Vertex> */;
        readonly links: any/* kotlin.collections.Iterable<Edge> */;
        target(link: Edge, node: Vertex): Vertex;
        getFrom(link: Edge): Vertex;
        getTo(link: Edge): Vertex;
        getLink(from: Vertex, to: Vertex): Nullable<Edge>;
        getLinks(from: Vertex): any/* kotlin.collections.Iterable<Edge> */;
        getNeighbors(from: Vertex): any/* kotlin.collections.Iterable<Vertex> */;
        readonly __doNotUseOrImplementIt: {
            readonly "org.molap.network.Graph": unique symbol;
        };
    }
}
export declare namespace org.molap.dataframe {
    class JsonDataFrame /* extends org.molap.dataframe.AbstractDataFrame<number, string, Nullable<any>> */ {
        constructor(array: Array<Nullable<any>>);
        static fromString(json: string): org.molap.dataframe.JsonDataFrame;
    }
}
export declare namespace com.treemap {
    class AlgorithmFactory {
        protected constructor(entries: Array<any/* com.treemap.Algorithm */>);
        add(entry: any/* com.treemap.Algorithm */): void;
        getDefault(): any/* com.treemap.Algorithm */;
        getAlgorithms(): kotlin.collections.KtList<any/* com.treemap.Algorithm */>;
        get(name: Nullable<string>): any/* com.treemap.Algorithm */;
        static get Companion(): {
            get BINARY_TREE(): any/* com.treemap.Algorithm */;
            get SLICE(): any/* com.treemap.Algorithm */;
            get SQUARIFIED(): any/* com.treemap.Algorithm */;
            get SQUARIFIEDPLUS(): any/* com.treemap.Algorithm */;
            get STRIP(): any/* com.treemap.Algorithm */;
            get PIVOT_BY_SPLIT_SIZE(): any/* com.treemap.Algorithm */;
            get SPLIT(): any/* com.treemap.Algorithm */;
            get CIRCULAR(): any/* com.treemap.Algorithm */;
            get CIRCLEPACKING(): any/* com.treemap.Algorithm */;
            get PIE(): any/* com.treemap.Algorithm */;
            get BAR(): any/* com.treemap.Algorithm */;
            get MATRIX(): any/* com.treemap.Algorithm */;
            get SUNBURST(): any/* com.treemap.Algorithm */;
            get ICICLE(): any/* com.treemap.Algorithm */;
            getInstance(): com.treemap.AlgorithmFactory;
        };
    }
}
export declare namespace com.treemap {
    class CushionRendering /* extends com.treemap.AbstractRendering */ implements com.treemap.Rendering {
        constructor();
        paintNode<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): boolean;
        paintBorder<N, Row, Column>(g2: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        toString(): string;
        getPasses<N, Row, Column>(model: com.treemap.TreeMapModel<N, Row, Column>): number;
        getParentOrder<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, root: N, pass: number): any/* kotlin.collections.Iterable<N> */;
        getOrder<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, root: N, pass: number): any/* kotlin.collections.Iterable<N> */;
        paintParent<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        getRenderedShape<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, model: com.treemap.TreeMapModel<N, Row, Column>, node: N, shape: any/* org.mkui.geom.Shape */): any/* org.mkui.geom.Shape */;
        paintBackground<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        getNestingBackground<N, Row, Column>(node: N, model: com.treemap.TreeMapModel<N, Row, Column>): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        paintLabel<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        paintParentBorder<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, node: N, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */, model: com.treemap.TreeMapModel<N, Row, Column>): void;
        paintParentHighlight<N, Row, Column>(g2: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: Nullable<any>/* Nullable<org.mkui.geom.Shape> */): void;
        readonly __doNotUseOrImplementIt: com.treemap.Rendering["__doNotUseOrImplementIt"];
    }
}
export declare namespace com.treemap {
    const DefaultAlgorithmFactory: {
        get instance(): com.treemap.AlgorithmFactory;
    };
}
export declare namespace com.treemap {
    class DefaultTreeMapColumnSettings /* extends com.treemap.AbstractTreeMapColumnSettings */ {
        constructor(colorFactory: any/* org.mkui.color.MkColorFactory */, fontFactory: any/* org.mkui.font.CPFontFactory */, colorMapFactory: Nullable<any>/* Nullable<org.mkui.colormap.ColorMapFactory> */);
        protected get algorithm(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Algorithm>> */;
        protected get borderThickness(): any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        get labelingEffect(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Effect>> */;
        set labelingEffect(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Effect>> */);
        get labelingHorizontalAlignment(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        set labelingHorizontalAlignment(value: any/* com.macrofocus.common.properties.MutableProperty<number> */);
        get labelingVerticalAlignment(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        set labelingVerticalAlignment(value: any/* com.macrofocus.common.properties.MutableProperty<number> */);
        get labelingRendering(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Rendering>> */;
        set labelingRendering(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Rendering>> */);
        get headerEffect(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Effect>> */;
        set headerEffect(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Effect>> */);
        get headerHorizontalAlignment(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        set headerHorizontalAlignment(value: any/* com.macrofocus.common.properties.MutableProperty<number> */);
        get headerVerticalAlignment(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        set headerVerticalAlignment(value: any/* com.macrofocus.common.properties.MutableProperty<number> */);
        get headerRendering(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Rendering>> */;
        set headerRendering(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Rendering>> */);
        get tooltipRendering(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Rendering>> */;
        set tooltipRendering(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.EnhancedLabel.Rendering>> */);
        protected get _algorithm(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Algorithm>> */;
        protected set _algorithm(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Algorithm>> */);
        protected get _aggregation(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Aggregation>> */;
        protected set _aggregation(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Aggregation>> */);
        protected get _scale(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Scale>> */;
        protected set _scale(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Scale>> */);
        protected get _nesting(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Nesting>> */;
        protected set _nesting(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Nesting>> */);
        protected get _ordering(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Ordering>> */;
        protected set _ordering(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Ordering>> */);
        protected get orderingDirection(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Ordering.SortOrder>> */;
        protected set orderingDirection(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Ordering.SortOrder>> */);
        protected get orderingHorizontalVanishingPoint(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        protected set orderingHorizontalVanishingPoint(value: any/* com.macrofocus.common.properties.MutableProperty<number> */);
        protected get orderingVerticalVanishingPoint(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        protected set orderingVerticalVanishingPoint(value: any/* com.macrofocus.common.properties.MutableProperty<number> */);
        protected get _labeling(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Labeling>> */;
        protected set _labeling(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Labeling>> */);
        protected get _labelingFont(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.font.crossplatform.CPFont>> */;
        protected set _labelingFont(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.font.crossplatform.CPFont>> */);
        protected get _labelingForeground(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set _labelingForeground(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get _labelingBackground(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set _labelingBackground(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get labelingMinimumCharactersToDisplay(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */;
        protected set labelingMinimumCharactersToDisplay(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */);
        protected get labelingEffectOpacity(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */;
        protected set labelingEffectOpacity(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */);
        protected get labelingShrinkTextToFitShape(): any/* com.macrofocus.common.properties.MutableProperty<boolean> */;
        protected set labelingShrinkTextToFitShape(value: any/* com.macrofocus.common.properties.MutableProperty<boolean> */);
        protected get labelingResizeTextToFitShape(): any/* com.macrofocus.common.properties.MutableProperty<boolean> */;
        protected set labelingResizeTextToFitShape(value: any/* com.macrofocus.common.properties.MutableProperty<boolean> */);
        protected get labelingFloat(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */;
        protected set labelingFloat(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */);
        protected get labelingContrastEnhancement(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.ContrastEnhancement>> */;
        protected set labelingContrastEnhancement(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.labeling.ContrastEnhancement>> */);
        protected get nestingAmount(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */;
        protected set nestingAmount(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */);
        protected get nestingBackground(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set nestingBackground(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get _headerFont(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.font.crossplatform.CPFont>> */;
        protected set _headerFont(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.font.crossplatform.CPFont>> */);
        protected get _headerForeground(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set _headerForeground(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get _headerEffectColor(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set _headerEffectColor(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get _headerBackground(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set _headerBackground(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get headerMinimumCharactersToDisplay(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */;
        protected set headerMinimumCharactersToDisplay(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */);
        protected get headerEffectOpacity(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */;
        protected set headerEffectOpacity(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */);
        protected get headerInsets(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.graphics.Insets>> */;
        protected set headerInsets(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.graphics.Insets>> */);
        protected get tooltipFont(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.font.crossplatform.CPFont>> */;
        protected set tooltipFont(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.font.crossplatform.CPFont>> */);
        protected get tooltipForeground(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set tooltipForeground(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get tooltipShowLabel(): any/* com.macrofocus.common.properties.MutableProperty<boolean> */;
        protected set tooltipShowLabel(value: any/* com.macrofocus.common.properties.MutableProperty<boolean> */);
        protected get borderColor(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set borderColor(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get _borderThickness(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */;
        protected set _borderThickness(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<number>> */);
        protected get format(): Nullable<any>/* Nullable<com.macrofocus.common.properties.MutableProperty<Nullable<com.macrofocus.common.format.CPFormat<Nullable<any>>>>> */;
        protected set format(value: Nullable<any>/* Nullable<com.macrofocus.common.properties.MutableProperty<Nullable<com.macrofocus.common.format.CPFormat<Nullable<any>>>>> */);
        protected get colorMap(): Nullable<any>/* Nullable<com.macrofocus.common.properties.MutableProperty<Nullable<MutableColorMap>>> */;
        protected set colorMap(value: Nullable<any>/* Nullable<com.macrofocus.common.properties.MutableProperty<Nullable<MutableColorMap>>> */);
        getAlgorithmSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Algorithm>> */;
        protected createDefaultColorMap(column: Nullable<any>): Nullable<MutableColorMap>;
        static get Companion(): {
            getDefaultTooltipFont(fontFactory: any/* org.mkui.font.CPFontFactory */): any/* org.mkui.font.crossplatform.CPFont */;
            getDefaultLabelingFont(fontFactory: any/* org.mkui.font.CPFontFactory */): any/* org.mkui.font.crossplatform.CPFont */;
            getDefaultHeaderFont(fontFactory: any/* org.mkui.font.CPFontFactory */): any/* org.mkui.font.crossplatform.CPFont */;
        };
    }
}
export declare namespace com.treemap {
    class DefaultTreeMapModel<Row, Column> /* extends com.treemap.AbstractTreeMapModel<Row, Column> */ implements com.treemap.TreeMapModel<any/* com.treemap.AbstractTreeMapNode<Row, Column> */, Row, Column> {
        constructor(dataFrame: any/* org.molap.dataframe.DataFrame<Row, Column, Nullable<any>> */);
        get dataFrame(): Nullable<any>/* Nullable<org.molap.dataframe.DataFrame<Row, Column, Nullable<any>>> */;
        set dataFrame(value: Nullable<any>/* Nullable<org.molap.dataframe.DataFrame<Row, Column, Nullable<any>>> */);
        get dataFrameListener(): any/* org.molap.dataframe.DataFrameListener<Row, Column> */;
        getLabelName(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): Nullable<string>;
        getParent(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): Nullable<any>/* Nullable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        isRoot(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): boolean;
        getChildCount(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): number;
        getChildren(parent: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): any/* kotlin.collections.Iterable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        getChildrenOfTypeParent(parent: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): any/* kotlin.collections.Iterable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        getCushionImage(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): Nullable<any>/* Nullable<org.mkui.graphics.CPImage> */;
        getCushionColor(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        protected createLeafNode(row: Row): any/* com.treemap.AbstractTreeMapNode<Row, Column> */;
        getNodeForRow(row: Row): any/* com.treemap.AbstractTreeMapNode<Row, Column> */;
        protected createParentNode(name: any, groupByColumn: Column, childrenGroupByColumn: Nullable<Column>): any/* com.treemap.AbstractTreeMapNode<Row, Column> */;
        protected findChild(parent: any/* com.treemap.AbstractTreeMapNode<Row, Column> */, name: Nullable<any>): Nullable<any>/* Nullable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        protected addChildToParent(parent: any/* com.treemap.AbstractTreeMapNode<Row, Column> */, child: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): void;
        protected addChild(parent: any/* com.treemap.AbstractTreeMapNode<Row, Column> */, path: any/* kotlin.collections.Iterable<Nullable<any>> */, groupBy: any/* kotlin.collections.Iterable<Column> */, childrenGroupBy: any/* kotlin.collections.Iterable<Nullable<Column>> */, row: Row): void;
        getTreeMapColumn(columnIndex: number): Nullable<Column>;
        getTreeMapColumnByName(columnName: Nullable<string>): Nullable<Column>;
        get rowCount(): number;
        get columnCount(): number;
        columns(): any/* kotlin.collections.Iterable<Column> */;
        getColumnName(columnIndex: Column): Nullable<string>;
        getColumnClass(columnIndex: Column): any/* kotlin.reflect.KClass<UnknownType *> */;
        getValueAt(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */, columnIndex: Column): Nullable<any>;
        isEveryValueUnique(column: Nullable<Column>): boolean;
        getNumericMax(columnIndex: Nullable<Column>): Nullable<number>;
        getNumericMin(columnIndex: Nullable<Column>): Nullable<number>;
        setNumericMax(columnIndex: Nullable<Column>, max: number): void;
        setNumericMin(columnIndex: Nullable<Column>, min: number): void;
        createDefaultColorMap(column: Column): MutableColorMap;
        get colorFactory(): any/* org.mkui.color.MkColorFactory */;
        get settings(): com.treemap.TreeMapSettings<Column>;
        get properties(): any/* com.macrofocus.common.properties.MutableProperties<Nullable<string>> */;
        get probing(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.AbstractTreeMapNode<Row, Column>>> */;
        get highlighting(): any/* com.macrofocus.common.selection.MutableSelection<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        get selection(): any/* com.macrofocus.common.selection.MutableSelection<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        get filter(): any/* com.macrofocus.common.filter.MutableFilter<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        get search(): any/* com.macrofocus.common.filter.MutableFilter<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        get isDirty(): boolean;
        get colorProvider(): any/* org.mkui.color.ColorProvider<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        set colorProvider(value: any/* org.mkui.color.ColorProvider<com.treemap.AbstractTreeMapNode<Row, Column>> */);
        get groupByColumns(): any/* kotlin.collections.Iterable<Nullable<Column>> */;
        get sizeColumns(): any/* kotlin.collections.Iterable<Nullable<Column>> */;
        get colorColumns(): any/* kotlin.collections.Iterable<Nullable<Column>> */;
        get heightColumns(): any/* kotlin.collections.Iterable<Nullable<Column>> */;
        get labelsColumns(): any/* kotlin.collections.Iterable<Nullable<Column>> */;
        get tooltipColumns(): any/* kotlin.collections.Iterable<Nullable<Column>> */;
        getTreeMapColumnsInclude(includeNone: boolean): any/* kotlin.collections.Iterable<Nullable<Column>> */;
        getTreeMapColumnsByIndices(columns: Int32Array): kotlin.collections.KtList<Column>;
        getTreeMapColumns(columns: Array<Column>): kotlin.collections.KtList<Column>;
        getTreeMapColumnsByNames(columnNames: Array<Nullable<string>>): kotlin.collections.KtList<Column>;
        isNumericType(column: Column): boolean;
        isTemporalType(column: Column): boolean;
        isVisualType(column: Column): boolean;
        getSumSize(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): number;
        getColorMap(column: Nullable<Column>): Nullable<MutableColorMap>;
        getCategoricalColorMap(column: Column): MutableColorMap;
        getPredefinedColorMap(column: Column): MutableColorMap;
        getCustomColorMap(column: Column): MutableColorMap;
        setNestedShape(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */, shape: Nullable<any>/* Nullable<org.mkui.geom.Shape> */): void;
        getNestedShape(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): any/* org.mkui.geom.Shape */;
        getGroupByColumn(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): Nullable<Column>;
        getChildrenGroupByColumn(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): Nullable<Column>;
        isLeaf(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): boolean;
        parentPreorderEnumeration(parent: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): any/* kotlin.collections.Iterable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        preorderEnumeration(parent: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): any/* kotlin.collections.Iterable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        breadthFirstIterator(parent: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): any/* kotlin.collections.Iterable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        depthFirstIterator(parent: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): any/* kotlin.collections.Iterable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        getAggregateValue(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */, column: Nullable<Column>): Nullable<any>;
        getStringValue(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */, column: Column): Nullable<string>;
        get currentRoot(): Nullable<any>/* Nullable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        set currentRoot(value: Nullable<any>/* Nullable<com.treemap.AbstractTreeMapNode<Row, Column>> */);
        addListener(treeMapListener: any/* com.treemap.TreeMapListener */): void;
        removeListener(treeMapListener: any/* com.treemap.TreeMapListener */): void;
        getNode(position: Nullable<any>/* Nullable<org.mkui.geom.Point> */): Nullable<any>/* Nullable<com.treemap.AbstractTreeMapNode<Row, Column>> */;
        waitUntilReady(): void;
        getColor(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */): any/* org.mkui.color.crossplatform.CPColor */;
        setColor(node: any/* com.treemap.AbstractTreeMapNode<Row, Column> */, color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        progressProperty(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        getFormatPattern(columnIndex: number): Nullable<string>;
        setFormatPattern(columnIndex: number, pattern: Nullable<string>): void;
        readonly __doNotUseOrImplementIt: com.treemap.TreeMapModel<any/* com.treemap.AbstractTreeMapNode<Row, Column> */, Row, Column>["__doNotUseOrImplementIt"];
    }
}
export declare namespace com.treemap {
    class DefaultTreeMapSettings<N extends unknown/* com.treemap.MutableTreeMapNode<Column> */, Column> /* extends com.treemap.AbstractTreeMapSettings<Column> */ implements com.treemap.TreeMapSettings<Column> {
        constructor(model: com.treemap.TreeMapModel<N, any /*UnknownType **/, Column>, colorFactory: any/* org.mkui.color.MkColorFactory */, fontFactory: any/* org.mkui.font.CPFontFactory */, colorMapFactory: any/* org.mkui.colormap.ColorMapFactory */);
        get properties(): any/* com.macrofocus.common.properties.MutableProperties<Nullable<string>> */;
        protected get _model(): com.treemap.TreeMapModel<N, any /*UnknownType **/, Column>;
        protected get groupByVariables(): any/* com.macrofocus.common.selection.MutableSelection<Column> */;
        protected get sizeVariable(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        protected get colorVariable(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        protected get labelVariable(): any/* com.macrofocus.common.selection.MutableSelection<Column> */;
        protected get toolTipVariable(): any/* com.macrofocus.common.selection.MutableSelection<Column> */;
        protected get backgroundVariable(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        protected get heightVariable(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        protected get progressive(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Progressive>> */;
        protected get depth(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Depth>> */;
        get renderingSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Rendering>> */;
        protected get groupByFields(): any/* com.macrofocus.common.properties.MutableProperty<kotlin.collections.KtList<Column>> */;
        protected set groupByFields(value: any/* com.macrofocus.common.properties.MutableProperty<kotlin.collections.KtList<Column>> */);
        get groupByColumns(): kotlin.collections.KtList<Column>;
        set groupByColumns(value: kotlin.collections.KtList<Column>);
        protected get labelsFields(): any/* com.macrofocus.common.properties.MutableProperty<kotlin.collections.KtList<Column>> */;
        protected set labelsFields(value: any/* com.macrofocus.common.properties.MutableProperty<kotlin.collections.KtList<Column>> */);
        get labelsColumns(): kotlin.collections.KtList<Column>;
        set labelsColumns(value: kotlin.collections.KtList<Column>);
        protected get toolTipFields(): any/* com.macrofocus.common.properties.MutableProperty<kotlin.collections.KtList<Column>> */;
        protected set toolTipFields(value: any/* com.macrofocus.common.properties.MutableProperty<kotlin.collections.KtList<Column>> */);
        get toolTipColumns(): kotlin.collections.KtList<Column>;
        set toolTipColumns(value: kotlin.collections.KtList<Column>);
        protected get sizeField(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<Column>> */;
        protected set sizeField(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<Column>> */);
        get sizeColumn(): Nullable<Column>;
        set sizeColumn(value: Nullable<Column>);
        get colorColumn(): Nullable<Column>;
        set colorColumn(value: Nullable<Column>);
        protected get backgroundField(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<Column>> */;
        protected set backgroundField(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<Column>> */);
        get backgroundColumn(): Nullable<Column>;
        set backgroundColumn(value: Nullable<Column>);
        protected get heightField(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<Column>> */;
        protected set heightField(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<Column>> */);
        get heightColumn(): Nullable<Column>;
        set heightColumn(value: Nullable<Column>);
        protected get _depth(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Depth>> */;
        protected set _depth(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Depth>> */);
        protected get _rendering(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Rendering>> */;
        protected set _rendering(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<com.treemap.Rendering>> */);
        get rendering(): Nullable<com.treemap.Rendering>;
        set rendering(value: Nullable<com.treemap.Rendering>);
        get maximumHeightInterval(): any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        protected get maximumHeight(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        get lightSourceHeightInterval(): any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        set lightSourceHeightInterval(value: any/* com.macrofocus.common.interval.MutableBoundedInterval */);
        protected get lightSourceHeight(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        get lightSourceAmbientInterval(): any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        protected get lightSourceAmbient(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        get lightSourceXInterval(): any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        protected get lightSourceX(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        get lightSourceYInterval(): any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        protected get lightSourceY(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        get lightSourceZInterval(): any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        protected get lightSourceZ(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        protected get _background(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set _background(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get _tooltipBackground(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set _tooltipBackground(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get _probingColor(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set _probingColor(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get _selectionColor(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        protected set _selectionColor(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */);
        protected get hideSearchResults(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */;
        protected set hideSearchResults(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */);
        protected get hideFilterResults(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */;
        protected set hideFilterResults(value: any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */);
        getGroupByColumnsSelection(): any/* com.macrofocus.common.selection.MutableSelection<Column> */;
        getSizeColumnSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        getColorColumnSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        getLabelColumnsSelection(): any/* com.macrofocus.common.selection.MutableSelection<Column> */;
        getTooltipColumnsSelection(): any/* com.macrofocus.common.selection.MutableSelection<Column> */;
        getBackgroundColumnSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        getHeightColumnSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        getDepthSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Depth>> */;
        getProgressiveSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Progressive>> */;
        getHideFilterResultsSelection(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */;
        getHideSearchResultsSelection(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */;
        protected createDefaultTreeMapColumnSettings(): any/* com.treemap.TreeMapColumnSettings */;
        protected createOverridingTreeMapColumnSettings(defaultSettings: any/* com.treemap.TreeMapColumnSettings */, model: Nullable<com.treemap.TreeMapModel<N, any /*UnknownType **/, Column>>, field: Nullable<Column>): any/* com.treemap.TreeMapColumnSettings */;
        getDefaultColumnSettings(): any/* com.treemap.TreeMapColumnSettings */;
        getColumnSettings(field: Nullable<Column>): any/* com.treemap.TreeMapColumnSettings */;
        getDimensionFixed(): Nullable<boolean>;
        setDimensionFixed(fixed: Nullable<boolean>): void;
        getDimension(): Nullable<any>/* Nullable<com.macrofocus.common.geom.Dimension> */;
        setDimension(dimension: Nullable<any>/* Nullable<com.macrofocus.common.geom.Dimension> */): void;
        getProgressive(): Nullable<any>/* Nullable<com.treemap.Progressive> */;
        setProgressive(progressive: Nullable<any>/* Nullable<com.treemap.Progressive> */): void;
        getMaximumHeight(): number;
        setMaximumHeight(height: number): void;
        isHideFilterResults(): Nullable<boolean>;
        isHideSearchResults(): Nullable<boolean>;
        setGroupBy(columns: Int32Array): void;
        setGroupByByNames(columnNames: Array<Nullable<string>>): void;
        setLabels(columns: Int32Array): void;
        setLabelsByNames(columnNames: Array<Nullable<string>>): void;
        setToolTip(columns: Int32Array): void;
        setToolTipByNames(columns: Array<Nullable<string>>): void;
        getShowPopup(field: Nullable<Column>): boolean;
        setShowPopup(field: Nullable<Column>, show: boolean): void;
        setBackground(column: number): void;
        setBackgroundByName(columnName: Nullable<string>): void;
        setSize(column: number): void;
        setSizeByName(columnName: Nullable<string>): void;
        setColor(column: number): void;
        setColorByName(columnName: Nullable<string>): void;
        setHeight(column: number): void;
        setHeightByName(columnName: Nullable<string>): void;
        getDepth(): Nullable<any>/* Nullable<com.treemap.Depth> */;
        setDepth(depth: Nullable<any>/* Nullable<com.treemap.Depth> */): void;
        setHideFilterResults(hideFilterResults: Nullable<boolean>): void;
        setHideSearchResults(hideSearchResults: Nullable<boolean>): void;
        getLightSourceHeight(): number;
        setLightSourceHeight(value: number): void;
        getLightSourceAmbient(): number;
        setLightSourceAmbient(value: number): void;
        getLightSourceX(): number;
        setLightSourceX(value: number): void;
        getLightSourceY(): number;
        setLightSourceY(value: number): void;
        getLightSourceZ(): number;
        setLightSourceZ(value: number): void;
        getBackgroundProperty(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        getBackground(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setBackgroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getTooltipBackgroundProperty(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        getTooltipBackground(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setTooltipBackground(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getProbingColorProperty(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        getProbingColor(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setProbingColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getSelectionColorProperty(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        getSelectionColor(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setSelectionColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getValue(key: Nullable<string>): Nullable<any>;
        resetToDefaults(): void;
        save(dataFrame: any/* org.molap.dataframe.DataFrame<Nullable<any>, Column, Nullable<any>> */, elementFactory: any/* com.macrofocus.common.persistence.ElementFactory */, root: any/* com.macrofocus.common.persistence.Element */): void;
        addTreeMapSettingsListener(listener: any/* com.treemap.TreeMapSettingsListener */): void;
        removeTreeMapSettingsListener(listener: any/* com.treemap.TreeMapSettingsListener */): void;
        removeTreeMapSettingsListeners(): void;
        readonly __doNotUseOrImplementIt: com.treemap.TreeMapSettings<Column>["__doNotUseOrImplementIt"];
    }
}
export declare namespace com.treemap {
    class FlatNoBorderRendering extends com.treemap.FlatRendering {
        constructor();
        toString(): string;
        getPasses<N, Row, Column>(model: com.treemap.TreeMapModel<N, Row, Column>): number;
        getParentOrder<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, root: N, pass: number): any/* kotlin.collections.Iterable<N> */;
        getOrder<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, root: N, pass: number): any/* kotlin.collections.Iterable<N> */;
        paintParent<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        getRenderedShape<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, model: com.treemap.TreeMapModel<N, Row, Column>, node: N, shape: any/* org.mkui.geom.Shape */): any/* org.mkui.geom.Shape */;
        paintBackground<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        getNestingBackground<N, Row, Column>(node: N, model: com.treemap.TreeMapModel<N, Row, Column>): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        paintLabel<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        paintParentBorder<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, node: N, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */, model: com.treemap.TreeMapModel<N, Row, Column>): void;
        paintParentHighlight<N, Row, Column>(g2: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: Nullable<any>/* Nullable<org.mkui.geom.Shape> */): void;
    }
}
export declare namespace com.treemap {
    class FlatRendering /* extends com.treemap.AbstractRendering */ implements com.treemap.Rendering {
        constructor();
        get drawBorder(): boolean;
        set drawBorder(value: boolean);
        paintNode<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): boolean;
        paintBorder<N, Row, Column>(g2: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        toString(): string;
        getPasses<N, Row, Column>(model: com.treemap.TreeMapModel<N, Row, Column>): number;
        getParentOrder<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, root: N, pass: number): any/* kotlin.collections.Iterable<N> */;
        getOrder<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, root: N, pass: number): any/* kotlin.collections.Iterable<N> */;
        paintParent<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        getRenderedShape<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, model: com.treemap.TreeMapModel<N, Row, Column>, node: N, shape: any/* org.mkui.geom.Shape */): any/* org.mkui.geom.Shape */;
        paintBackground<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        getNestingBackground<N, Row, Column>(node: N, model: com.treemap.TreeMapModel<N, Row, Column>): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        paintLabel<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        paintParentBorder<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, node: N, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */, model: com.treemap.TreeMapModel<N, Row, Column>): void;
        paintParentHighlight<N, Row, Column>(g2: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: Nullable<any>/* Nullable<org.mkui.geom.Shape> */): void;
        readonly __doNotUseOrImplementIt: com.treemap.Rendering["__doNotUseOrImplementIt"];
    }
}
export declare namespace com.treemap {
    class OverridingTreeMapColumnSettings /* extends com.treemap.AbstractTreeMapColumnSettings */ {
        constructor(defaultSettings: any/* com.treemap.TreeMapColumnSettings */);
        getBorderThicknessProperty(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        setPropertyOverride(key: Nullable<string>, value: Nullable<any>): void;
    }
}
export declare namespace com.treemap {
    interface Rendering {
        getPasses<N, Row, Column>(model: com.treemap.TreeMapModel<N, Row, Column>): number;
        paintParent<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        paintParentBorder<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, node: N, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */, model: com.treemap.TreeMapModel<N, Row, Column>): void;
        paintNode<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): boolean;
        paintBackground<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        paintLabel<N, Row, Column>(g: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, passes: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        paintParentHighlight<N, Row, Column>(g2: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: Nullable<any>/* Nullable<org.mkui.geom.Shape> */): void;
        paintBorder<N, Row, Column>(g2: any/* com.treemap.crossplatform.TGraphics */, view: any/* com.treemap.TreeMapView<N, Row, Column> */, node: N, pass: number, bounds: any/* org.mkui.geom.Rectangle */, shape: any/* org.mkui.geom.Shape */): void;
        getParentOrder<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, root: N, pass: number): any/* kotlin.collections.Iterable<N> */;
        getOrder<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, root: N, pass: number): any/* kotlin.collections.Iterable<N> */;
        getRenderedShape<N, Row, Column>(view: any/* com.treemap.TreeMapView<N, Row, Column> */, model: com.treemap.TreeMapModel<N, Row, Column>, node: N, shape: any/* org.mkui.geom.Shape */): any/* org.mkui.geom.Shape */;
        getNestingBackground<N, Row, Column>(node: N, model: com.treemap.TreeMapModel<N, Row, Column>): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        readonly __doNotUseOrImplementIt: {
            readonly "com.treemap.Rendering": unique symbol;
        };
    }
}
export declare namespace com.treemap {
    class RenderingFactory {
        private constructor();
        add(entry: com.treemap.Rendering): void;
        getDefault(): com.treemap.Rendering;
        getRenderings(): kotlin.collections.KtList<com.treemap.Rendering>;
        get(name: Nullable<string>): com.treemap.Rendering;
        static get Companion(): {
            get CUSHION(): com.treemap.Rendering;
            get FLAT(): com.treemap.Rendering;
            get FLAT_NO_BORDER(): com.treemap.Rendering;
            get instance(): com.treemap.RenderingFactory;
        };
    }
}
export declare namespace com.treemap {
    interface TreeMap<N, Row, Column> {
        readonly component: any/* org.mkui.component.CPComponent */;
        model: Nullable<com.treemap.TreeMapModel<N, Row, Column>>;
        view: Nullable<any>/* Nullable<com.treemap.TreeMapView<N, Row, Column>> */;
        controller: Nullable<any>/* Nullable<com.treemap.TreeMapController<N, Row, Column>> */;
        setGroupBy(columns: Int32Array): void;
        setGroupByByNames(columnNames: Array<Nullable<string>>): void;
        setLabels(columns: Int32Array): void;
        setLabelsByNames(columnNames: Array<Nullable<string>>): void;
        setBackground(column: number): void;
        setBackgroundByName(columnName: Nullable<string>): void;
        setSize(column: number): void;
        setSizeByName(columnName: Nullable<string>): void;
        setColor(column: number): void;
        setColorByName(columnName: Nullable<string>): void;
        setHeight(column: number): void;
        setHeightByName(columnName: Nullable<string>): void;
        setToolTip(columns: Int32Array): void;
        setToolTipByNames(columnNames: Array<Nullable<string>>): void;
        setAlgorithm(algorithm: Nullable<any>/* Nullable<com.treemap.Algorithm> */): void;
        setAggregation(aggregation: Nullable<any>/* Nullable<com.treemap.Aggregation> */): void;
        setScale(scale: Nullable<any>/* Nullable<com.treemap.Scale> */): void;
        setNesting(nesting: Nullable<any>/* Nullable<com.treemap.Nesting> */): void;
        setOrdering(ordering: Nullable<any>/* Nullable<com.treemap.Ordering> */): void;
        setDepth(depth: Nullable<any>/* Nullable<com.treemap.Depth> */): void;
        setLabeling(labeling: Nullable<any>/* Nullable<com.treemap.Labeling> */): void;
        setRendering(rendering: Nullable<com.treemap.Rendering>): void;
        setLightSourceHeight(value: number): void;
        setLightSourceAmbient(value: number): void;
        setLightSourceX(value: number): void;
        setLightSourceY(value: number): void;
        setLightSourceZ(value: number): void;
        setLabelingFont(font: Nullable<any>/* Nullable<org.mkui.font.crossplatform.CPFont> */): void;
        setLabelingForegroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        setLabelingBackgroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        setHeaderFont(font: Nullable<any>/* Nullable<org.mkui.font.crossplatform.CPFont> */): void;
        setHeaderForegroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        setHeaderBackgroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        readonly __doNotUseOrImplementIt: {
            readonly "com.treemap.TreeMap": unique symbol;
        };
    }
}
export declare namespace com.treemap {
    interface TreeMapModel<N, Row, Column> extends TreeMapAccessor<N> {
        readonly dataFrame: Nullable<any>/* Nullable<org.molap.dataframe.DataFrame<Row, Column, UnknownType *>> */;
        readonly properties: any/* com.macrofocus.common.properties.MutableProperties<Nullable<string>> */;
        readonly groupByColumns: any/* kotlin.collections.Iterable<Nullable<Column>> */;
        readonly sizeColumns: any/* kotlin.collections.Iterable<Nullable<Column>> */;
        readonly colorColumns: any/* kotlin.collections.Iterable<Nullable<Column>> */;
        readonly heightColumns: any/* kotlin.collections.Iterable<Nullable<Column>> */;
        readonly labelsColumns: any/* kotlin.collections.Iterable<Nullable<Column>> */;
        readonly tooltipColumns: any/* kotlin.collections.Iterable<Nullable<Column>> */;
        isNumericType(column: Column): boolean;
        isTemporalType(column: Column): boolean;
        isVisualType(column: Column): boolean;
        getColorMap(column: Nullable<Column>): Nullable<MutableColorMap>;
        getCategoricalColorMap(column: Column): MutableColorMap;
        getPredefinedColorMap(column: Column): MutableColorMap;
        getCustomColorMap(column: Column): MutableColorMap;
        createDefaultColorMap(column: Column): Nullable<MutableColorMap>;
        readonly maximumSize: number;
        setNestedShape(node: N, shape: Nullable<any>/* Nullable<org.mkui.geom.Shape> */): void;
        getNestedShape(node: N): Nullable<any>/* Nullable<org.mkui.geom.Shape> */;
        getGroupByColumn(node: N): Nullable<Column>;
        getChildrenGroupByColumn(node: N): Nullable<Column>;
        getLabelName(node: N): Nullable<string>;
        colorProvider: any/* org.mkui.color.ColorProvider<N> */;
        setColor(node: N, color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getColor(node: N): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        isLeaf(node: N): boolean;
        getParent(node: N): Nullable<N>;
        isRoot(node: N): boolean;
        getChildren(parent: N): any/* kotlin.collections.Iterable<N> */;
        getChildrenOfTypeParent(parent: N): any/* kotlin.collections.Iterable<N> */;
        getChildCount(node: N): number;
        getCushionImage(node: N): Nullable<any>/* Nullable<org.mkui.graphics.CPImage> */;
        getCushionColor(node: N): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        parentPreorderEnumeration(parent: N): any/* kotlin.collections.Iterable<N> */;
        preorderEnumeration(parent: N): any/* kotlin.collections.Iterable<N> */;
        breadthFirstIterator(parent: N): any/* kotlin.collections.Iterable<N> */;
        depthFirstIterator(parent: N): any/* kotlin.collections.Iterable<N> */;
        getNodeForRow(row: Row): N;
        getTreeMapColumn(columnIndex: number): Nullable<Column>;
        getTreeMapColumnByName(columnName: Nullable<string>): Nullable<Column>;
        getTreeMapColumnsInclude(includeNone: boolean): any/* kotlin.collections.Iterable<Nullable<Column>> */;
        getTreeMapColumnsByIndices(columns: Int32Array): kotlin.collections.KtList<Column>;
        getTreeMapColumns(columns: Array<Column>): kotlin.collections.KtList<Column>;
        getTreeMapColumnsByNames(columnNames: Array<Nullable<string>>): kotlin.collections.KtList<Column>;
        getNumericMax(columnIndex: Nullable<Column>): Nullable<number>;
        getNumericMin(columnIndex: Nullable<Column>): Nullable<number>;
        setNumericMax(columnIndex: Nullable<Column>, max: number): void;
        setNumericMin(columnIndex: Nullable<Column>, min: number): void;
        readonly normalizedLightSourceX: number;
        readonly normalizedLightSourceY: number;
        readonly normalizedLightSourceZ: number;
        readonly rowCount: number;
        readonly columnCount: number;
        columns(): Nullable<any>/* Nullable<kotlin.collections.Iterable<Column>> */;
        getColumnName(columnIndex: Column): Nullable<string>;
        getColumnClass(columnIndex: Column): Nullable<any>/* Nullable<kotlin.reflect.KClass<UnknownType *>> */;
        getValueAt(node: N, columnIndex: Column): Nullable<any>;
        isEveryValueUnique(column: Nullable<Column>): boolean;
        getAggregateValue(node: N, column: Nullable<Column>): Nullable<any>;
        getStringValue(node: N, column: Column): Nullable<string>;
        readonly root: Nullable<N>;
        currentRoot: Nullable<N>;
        readonly probing: any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<N>> */;
        readonly highlighting: any/* com.macrofocus.common.selection.MutableSelection<N> */;
        readonly selection: any/* com.macrofocus.common.selection.MutableSelection<N> */;
        readonly filter: any/* com.macrofocus.common.filter.MutableFilter<N> */;
        readonly search: any/* com.macrofocus.common.filter.MutableFilter<N> */;
        readonly settings: com.treemap.TreeMapSettings<Column>;
        readonly worker: Nullable<any>/* Nullable<com.treemap.TreeMapWorker> */;
        readonly workerFuture: Nullable<any>/* Nullable<com.macrofocus.common.command.Future<UnknownType *>> */;
        addListener(treeMapListener: any/* com.treemap.TreeMapListener */): void;
        removeListener(treeMapListener: any/* com.treemap.TreeMapListener */): void;
        getNode(position: Nullable<any>/* Nullable<org.mkui.geom.Point> */): Nullable<N>;
        readonly isDirty: boolean;
        waitUntilReady(): void;
        getSumSize(node: N): number;
        progressProperty(): any/* com.macrofocus.common.properties.MutableProperty<number> */;
        getFormatPattern(columnIndex: number): Nullable<string>;
        setFormatPattern(columnIndex: number, pattern: Nullable<string>): void;
        readonly colorFactory: any/* org.mkui.color.MkColorFactory */;
        readonly __doNotUseOrImplementIt: {
            readonly "com.treemap.TreeMapModel": unique symbol;
        };
    }
}
export declare namespace com.treemap {
    interface TreeMapSettings<Column> {
        readonly properties: any/* com.macrofocus.common.properties.MutableProperties<Nullable<string>> */;
        getDimensionFixed(): Nullable<boolean>;
        setDimensionFixed(fixed: Nullable<boolean>): void;
        getDimension(): Nullable<any>/* Nullable<com.macrofocus.common.geom.Dimension> */;
        setDimension(dimension: Nullable<any>/* Nullable<com.macrofocus.common.geom.Dimension> */): void;
        getProgressive(): Nullable<any>/* Nullable<com.treemap.Progressive> */;
        setProgressive(progressive: Nullable<any>/* Nullable<com.treemap.Progressive> */): void;
        groupByColumns: kotlin.collections.KtList<Column>;
        sizeColumn: Nullable<Column>;
        colorColumn: Nullable<Column>;
        labelsColumns: kotlin.collections.KtList<Column>;
        toolTipColumns: kotlin.collections.KtList<Column>;
        backgroundColumn: Nullable<Column>;
        heightColumn: Nullable<Column>;
        isHideFilterResults(): Nullable<boolean>;
        setHideFilterResults(hideFilterResults: Nullable<boolean>): void;
        isHideSearchResults(): Nullable<boolean>;
        setHideSearchResults(hideSearchResults: Nullable<boolean>): void;
        getMaximumHeight(): number;
        setMaximumHeight(height: number): void;
        setGroupBy(columns: Int32Array): void;
        setGroupByByNames(columnNames: Array<Nullable<string>>): void;
        setLabels(columns: Int32Array): void;
        setLabelsByNames(columnNames: Array<Nullable<string>>): void;
        setToolTip(columns: Int32Array): void;
        setToolTipByNames(columnNames: Array<Nullable<string>>): void;
        setBackground(column: number): void;
        setBackgroundByName(columnName: Nullable<string>): void;
        setSize(column: number): void;
        setSizeByName(columnName: Nullable<string>): void;
        setColor(column: number): void;
        setColorByName(columnName: Nullable<string>): void;
        setHeight(column: number): void;
        setHeightByName(columnName: Nullable<string>): void;
        getDepth(): Nullable<any>/* Nullable<com.treemap.Depth> */;
        setDepth(depth: Nullable<any>/* Nullable<com.treemap.Depth> */): void;
        rendering: Nullable<com.treemap.Rendering>;
        getLightSourceHeight(): number;
        setLightSourceHeight(value: number): void;
        getLightSourceAmbient(): number;
        setLightSourceAmbient(value: number): void;
        getLightSourceX(): number;
        setLightSourceX(value: number): void;
        getLightSourceY(): number;
        setLightSourceY(value: number): void;
        getLightSourceZ(): number;
        setLightSourceZ(value: number): void;
        getBackgroundProperty(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        getBackground(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setBackgroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getTooltipBackgroundProperty(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        getTooltipBackground(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setTooltipBackground(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getProbingColorProperty(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        getProbingColor(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setProbingColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getSelectionColorProperty(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<org.mkui.color.crossplatform.CPColor>> */;
        getSelectionColor(): Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */;
        setSelectionColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        getShowPopup(field: Nullable<Column>): boolean;
        setShowPopup(field: Nullable<Column>, show: boolean): void;
        getValue(key: Nullable<string>): Nullable<any>;
        addTreeMapSettingsListener(listener: any/* com.treemap.TreeMapSettingsListener */): void;
        removeTreeMapSettingsListener(listener: any/* com.treemap.TreeMapSettingsListener */): void;
        removeTreeMapSettingsListeners(): void;
        getGroupByColumnsSelection(): any/* com.macrofocus.common.selection.MutableSelection<Column> */;
        getSizeColumnSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        getColorColumnSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        getLabelColumnsSelection(): any/* com.macrofocus.common.selection.MutableSelection<Column> */;
        getTooltipColumnsSelection(): any/* com.macrofocus.common.selection.MutableSelection<Column> */;
        getBackgroundColumnSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        getHeightColumnSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<Column>> */;
        getDepthSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Depth>> */;
        readonly renderingSelection: any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Rendering>> */;
        getProgressiveSelection(): any/* com.macrofocus.common.selection.MutableSingleSelection<Nullable<com.treemap.Progressive>> */;
        getHideFilterResultsSelection(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */;
        getHideSearchResultsSelection(): any/* com.macrofocus.common.properties.MutableProperty<Nullable<boolean>> */;
        getDefaultColumnSettings(): any/* com.treemap.TreeMapColumnSettings */;
        getColumnSettings(field: Nullable<Column>): any/* com.treemap.TreeMapColumnSettings */;
        readonly maximumHeightInterval: any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        readonly lightSourceHeightInterval: any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        readonly lightSourceAmbientInterval: any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        readonly lightSourceXInterval: any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        readonly lightSourceYInterval: any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        readonly lightSourceZInterval: any/* com.macrofocus.common.interval.MutableBoundedInterval */;
        resetToDefaults(): void;
        save(dataFrame: any/* org.molap.dataframe.DataFrame<Nullable<any>, Column, Nullable<any>> */, elementFactory: any/* com.macrofocus.common.persistence.ElementFactory */, root: any/* com.macrofocus.common.persistence.Element */): void;
        readonly __doNotUseOrImplementIt: {
            readonly "com.treemap.TreeMapSettings": unique symbol;
        };
    }
}
export declare namespace com.treemap {
    class JsTreeMap /* extends com.treemap.DefaultTreeMap<number, string> */ implements com.treemap.TreeMap<any/* com.treemap.AbstractTreeMapNode<number, string> */, number, string> {
        constructor(elementId: string, model: Nullable<com.treemap.DefaultTreeMapModel<number, string>>);
        get component(): any/* org.mkui.component.CPComponent */;
        get view(): Nullable<any>/* Nullable<com.treemap.TreeMapView<com.treemap.AbstractTreeMapNode<number, string>, number, string>> */;
        set view(value: Nullable<any>/* Nullable<com.treemap.TreeMapView<com.treemap.AbstractTreeMapNode<number, string>, number, string>> */);
        get controller(): Nullable<any>/* Nullable<com.treemap.TreeMapController<com.treemap.AbstractTreeMapNode<number, string>, number, string>> */;
        set controller(value: Nullable<any>/* Nullable<com.treemap.TreeMapController<com.treemap.AbstractTreeMapNode<number, string>, number, string>> */);
        get model(): Nullable<com.treemap.TreeMapModel<any/* com.treemap.AbstractTreeMapNode<number, string> */, number, string>>;
        set model(value: Nullable<com.treemap.TreeMapModel<any/* com.treemap.AbstractTreeMapNode<number, string> */, number, string>>);
        setGroupBy(columns: Int32Array): void;
        setGroupByByNames(columnNames: Array<Nullable<string>>): void;
        setLabels(columns: Int32Array): void;
        setLabelsByNames(columnNames: Array<Nullable<string>>): void;
        setBackground(column: number): void;
        setBackgroundByName(columnName: Nullable<string>): void;
        setSize(column: number): void;
        setSizeByName(columnName: Nullable<string>): void;
        setColor(column: number): void;
        setColorByName(columnName: Nullable<string>): void;
        setHeight(column: number): void;
        setHeightByName(columnName: Nullable<string>): void;
        setToolTip(columns: Int32Array): void;
        setToolTipByNames(columnNames: Array<Nullable<string>>): void;
        setAlgorithm(algorithm: Nullable<any>/* Nullable<com.treemap.Algorithm> */): void;
        setAggregation(aggregation: Nullable<any>/* Nullable<com.treemap.Aggregation> */): void;
        setScale(scale: Nullable<any>/* Nullable<com.treemap.Scale> */): void;
        setNesting(nesting: Nullable<any>/* Nullable<com.treemap.Nesting> */): void;
        setOrdering(ordering: Nullable<any>/* Nullable<com.treemap.Ordering> */): void;
        setDepth(depth: Nullable<any>/* Nullable<com.treemap.Depth> */): void;
        setLabeling(labeling: Nullable<any>/* Nullable<com.treemap.Labeling> */): void;
        setRendering(rendering: Nullable<com.treemap.Rendering>): void;
        setLightSourceHeight(value: number): void;
        setLightSourceAmbient(value: number): void;
        setLightSourceX(value: number): void;
        setLightSourceY(value: number): void;
        setLightSourceZ(value: number): void;
        setLabelingFont(font: Nullable<any>/* Nullable<org.mkui.font.crossplatform.CPFont> */): void;
        setLabelingForegroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        setLabelingBackgroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        setHeaderFont(font: Nullable<any>/* Nullable<org.mkui.font.crossplatform.CPFont> */): void;
        setHeaderForegroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        setHeaderBackgroundColor(color: Nullable<any>/* Nullable<org.mkui.color.crossplatform.CPColor> */): void;
        readonly __doNotUseOrImplementIt: com.treemap.TreeMap<any/* com.treemap.AbstractTreeMapNode<number, string> */, number, string>["__doNotUseOrImplementIt"];
    }
}
export declare namespace com.treemap {
    interface TreeMapProps extends Props {
        model?: Nullable<com.treemap.DefaultTreeMapModel<number, string>>;
    }
}
export declare namespace com.treemap {
    const TreeMapComponent: FC<com.treemap.TreeMapProps>;
}